#  A mud client for
#  Dawn of the Ages  http://dawn.rplay.net
#
#  Copyright (C) 2001,2002 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import string
import Client
try:
    import Term
except:
    pass

class ColorState:
    def __init__(self):
        self.bold = 0
        self.reverse = 0
        self.color = None
        self.underline = 0

        self.tagops = { "m": (0, 0, 0, 0),
                        "0m" : (0, 0, 0, 0),
                        "1m" : (None, 1, None, None),
                        "4m" : (None, None, None, 1),
                        "7m" : (None, None, 1, None),
                        "1m" : (None, 1, None, None),
                        "30m" : ("black", None, None, None),
                        "31m" : ("red", None, None, None),
                        "32m" : ("green", None, None, None),
                        "33m" : ("yellow", None, None, None),
                        "34m" : ("blue", None, None, None),
                        "35m" : ("magenta", None, None, None),
                        "36m" : ("cyan", None, None, None),
                        "37m" : ("white", None, None, None),
                        "1;30m" : ("black", 1, None, None),
                        "1;31m" : ("red", 1, None, None),
                        "1;32m" : ("green", 1, None, None),
                        "1;33m" : ("yellow", 1, None, None),
                        "1;34m" : ("blue", 1, None, None),
                        "1;35m" : ("magenta", 1, None, None),
                        "1;36m" : ("cyan", 1, None, None),
                        "1;37m" : ("white", 1, None, None),
                        "0;30m" : ("black", 0, None, None),
                        "0;31m" : ("red", 0, None, None),
                        "0;32m" : ("green", 0, None, None),
                        "0;33m" : ("yellow", 0, None, None),
                        "0;34m" : ("blue", 0, None, None),
                        "0;35m" : ("magenta", 0, None, None),
                        "0;36m" : ("cyan", 0, None, None),
                        "0;37m" : ("white", 0, None, None)}



    def change_state(self, txt):
        if self.tagops.has_key(txt):
            (color, bold, reverse, underline)  = self.tagops[txt]
            if color != None:
                self.color = color
            if bold != None:
                self.bold = bold
            if reverse != None:
                self.reverse = reverse
            if underline != None:
                self.underline = underline

            

    def change(self, txt):
        #print "\nchange(%s):" % txt
        if startswith(txt,"[m"):
            self.color = None
            self.bold = 0
            self.reverse = 0
            self.underline = 0
            txt = txt[2:]
        elif startswith(txt,"[0m"):
            self.color = None
            self.bold = 0
            self.reverse = 0
            self.underline = 0
            txt = txt[3:]
        elif startswith(txt,"[1m"):
            self.bold = 1
            txt = txt[3:]
        elif startswith(txt,"[4m"):
            self.underline = 1
            txt = txt[3:]
        elif startswith(txt,"[7m"):
            self.reverse = 1
            txt = txt[3:]
        elif startswith(txt,"[1m"):
            self.bold = 1
            txt = txt[3:]
        elif startswith(txt,"[30m"):
            self.color ="black"
            txt = txt[4:]
        elif startswith(txt,"[31m"):
            self.color ="red"
            txt = txt[4:]
        elif startswith(txt,"[32m"):
            self.color ="green"
            txt = txt[4:]
        elif startswith(txt,"[33m"):
            self.color ="yellow"
            txt = txt[4:]
        elif startswith(txt,"[34m"):
            self.color ="blue"
            txt = txt[4:]
        elif startswith(txt,"[35m"):
            self.color ="magenta"
            txt = txt[4:]
        elif startswith(txt,"[36m"):
            self.color ="cyan"
            txt = txt[4:]
        elif startswith(txt,"[37m"):
            self.color ="white"
            txt = txt[4:]
        elif startswith(txt,"[1;30m"):
            self.color ="black"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;31m"):
            self.color ="red"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;32m"):
            self.color ="green"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;33m"):
            self.color ="yellow"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;34m"):
            self.color ="blue"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;35m"):
            self.color ="magenta"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;36m"):
            self.color ="cyan"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[1;37m"):
            self.color ="white"
            self.bold = 1
            txt = txt[6:]
        elif startswith(txt,"[0;30m"):
            self.color ="black"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;31m"):
            self.color ="red"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;32m"):
            self.color ="green"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;33m"):
            self.color ="yellow"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;34m"):
            self.color ="blue"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;35m"):
            self.color ="magenta"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;36m"):
            self.color ="cyan"
            self.bold = 0
            txt = txt[6:]
        elif startswith(txt,"[0;37m"):
            self.color ="white"
            self.bold = 0
            txt = txt[6:]


        #print "state v:%s b:%s c:%s\n" % (self.reverse, self.bold, self.color)
        


        return txt

    def getTag(self):
        if self.color:
            erg = self.color;
            if self.bold:
                erg = "b"+erg
            if self.reverse:
                erg = "v"+erg
            if self.underline:
                erg = "u"+erg
            return erg
        else:
            return "normal"

def ansitostring(symbol):
    """converts ansi-codes into mud-style string colorcodes """
    global colorcodes
    global colorcodes_bright
    text = ""
    colorstate = ColorState()
    pos = string.find(symbol,"\33")
    if pos < 0:
        text = symbol
    else:
        wasbright=0
        while pos >= 0:
            text = text + symbol[:pos]
            symbol = colorstate.change(symbol[pos+1:])
            codes = None
            if colorstate.bold:
                wasbright=1
                codes=colorcodes_bright
            else:
                if wasbright:
                    text = text+"#n"
                    wasbright=0
                codes=colorcodes
            if colorstate.color:
                text = text +codes[colorstate.color] 
            elif colorstate.bold:
                text=text+"#d"
            if colorstate.underline:
                text=text+"#u"
            if colorstate.reverse:
                text=text+"#v"
            pos = string.find(symbol,"\33")
           #symbol = symbol+"#n"
    return text

def startswith(txt,token):
    """checks if string txt starts with string token """
    if txt[:len(token)]==token:
        return 1
    else:
        return 0

#mapping of colornames to colorcodes
colorcodes = { "black":  "#l",
        "red":    "#r",
        "green":  "#g",
        "yellow": "#y",
        "blue":   "#b",
        "magenta":"#m",
        "cyan":   "#c",
        "white":  "#w" }

colorcodes_bright={ "black":  "#L",
        "red":    "#R",
        "green":  "#G",
        "yellow": "#Y",
        "blue":   "#B",
        "magenta":"#M",
        "cyan":   "#C",
        "white":  "#W" }

def stringtoansi(text):
   """ converts mud-style string-colorcodes to ansi-codes"""
   #global colorcodes
   #global colorcodes_bright
   symbol=""
   pos = string.find(text,"#")
   if pos < 0:
       return text
   else:
       bold = 0
       reverse = 0
       underline = 0
       color = None
       while pos >= 0:
           clr=0
           symbol = symbol + text[:pos]
           text = text[pos+1:]
           if not startswith(text,"#"):
               for c in colorcodes.keys():
                   if colorcodes[c] == "#"+text[0]:
                       color=c
               for c in colorcodes_bright.keys():
                   if colorcodes_bright[c] == "#"+text[0]:
                       bold = 1
                       color = c
               if text[0] == "u":
                   underline = 1
               elif text[0] == "v":
                   reverse = 1
               elif text[0] == "d":
                   bold = 1
               elif text[0] == "n":
                   underline = 0
                   reverse = 0
                   bold = 0
                   clr=1
                   color = None

               if clr:
                       symbol=symbol+Client.clr()
               elif color:
                   symbol = symbol+Client.fcolor(Term.colors.index(color),bold=bold,reverse=reverse,underline=underline)
               else:
                   if bold:
                       symbol=symbol+Client.colors("bold")
                   if reverse:
                       symbol=symbol+Client.colors("reverse")
               if underline:
                   symbol=symbol+Client.colors("underline")
               text = text[1:]
           else:
               symbol=symbol+"#"
           pos = string.find(text,"#")
       return symbol+text

 
