#  A mud client for
#  Dawn of the Ages  http://dawn.rplay.net
#
#  Copyright (C) 2001,2002 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


import string

class Speedwalk:
    hash={
        "tour" : "nee:buy beer:wwseeessssen:buy tea:drink tea:sessss"
        } 


def path_commands(path):
    i = 0
    commands = []
    while i < len(path):
        command = ""
        c = path[i]
        i = i+1
        mul = 0
        while  c>="0" and c<="9":
            mul = mul * 10 + ord(c)-48
            c = path[i]
            i = i+1
        if (mul ==0):
            mul = 1
        if c == "u" or c=="d" or c=="n" or c=="e" or c=="s" or c=="w":
            command = c
        elif c=="$":
            c = path[i]
            i = i + 1
            command = "open "+c
        elif c=="#":
            c = path[i]
            i = i + 1
            command = "unlock "+c+";open "+c
        elif c==":":
            command = ""
            c = path[i]
            i = i+1
            while i<len(path) and c != ":":
                command=command +c
                c = path[i]
                i = i+1
                
        for j in range(mul):
            commands.append(command)
    return commands


##def sw(name):
##    """ walk the path stored under name in speedwalks
##    """
##    path = None
##    try:
##        path = speedwalks[name]
##    except:
##        pass
##    if path:
##        speedwalk(path)

    
def speedwalk(client, path):
    """ parse the given path as a speedwalk command string where
        u d n e s w  are a step in that direction
        $e   opens a door to the east
        #e   unlocks and opens a door to the east
        :command: executes the command
        every entry can be started with a number of repetitions:
        4u3e is executed as u u u u e e e
        speedwalks run synchronized (as in #delay -1)
    """
    #output("path:"+path+".")
    client.append_queue(path_commands(string.strip(path)))
    
def speedwalk_reverse(client, path):
    """ parse the given path as a speedwalk command string and walk it backwards
        (see help #speed) """
    client.append_queue(reverse_path_commands(string.strip(path)))

addcommand(client, "#speedrev", speedwalk_reverse)
reverse_dir = {}
reverse_dir["n"]="s"
reverse_dir["e"]="w"
reverse_dir["s"]="n"
reverse_dir["w"]="e"
reverse_dir["u"]="d"
reverse_dir["d"]="u"
    
def reverse_path_commands(path):
    i = 0
    commands = []
    while i < len(path):
        command = ""
        c = path[i]
        i = i+1
        mul = 0
        while  c>="0" and c<="9":
            mul = mul * 10 + ord(c)-48
            c = path[i]
            i = i+1
        if (mul ==0):
            mul = 1
        if c == "u" or c=="d" or c=="n" or c=="e" or c=="s" or c=="w":
            command = reverse_dir[c]
        elif c=="$":
            c = path[i]
            i = i + 1
            command = "open "+reverse_dir[c]
        elif c=="#":
            c = path[i]
            i = i + 1
            command = "unlock "+reverse_dir[c]+";open "+reverse_dir[c]
        elif c==":":
            command = ""
            c = path[i]
            i = i+1
            while i<len(path) and c != ":":
                command=command +c
                c = path[i]
                i = i+1
                
        for j in range(mul):
            commands.append(command)
    commands.reverse()
    return commands

 

addcommand(client, "#speed", speedwalk)

def sw(client, name):
    """    list all paths defined
    #sw <name>  walk the path stored under <name> in speedwalks
    #sw add <name> <path> add path to the list, keyed by <name>
    #sw del <name>  removes path from list
    #sw rev <name> walks the speedwalk backwards
    """
    path = None
    if len(name)<1:
        client.output("\nDefined paths:\n")
        keys = client.speedwalks.keys()
        if len(keys)<1:
            client.output("None.")
        else:
            keys.sort()
            for k in keys:
                client.output(""+k+" => "+client.speedwalks[k])
            client.output("\n")
        client.snl()
    else:
        erg = string.split(name," ", 2)
        #print "erg:",erg
        name = erg[0]
        if name == "add":
            if len(erg)>2:
                name = erg[1]
                path = erg[2]
                client.speedwalks[name]=path
                client.output(name+" walks "+path+"\n")
            else:
                client.output("usage: #sw add <name> <path>\n")
            client.snl()
        elif name == "del":
            if len(erg)>1:
                client.output("removed "+erg[1]+"\n")
                del client.speedwalks[erg[1]]
            else:
                client.output("usage: #sw del <name>\n")
            client.snl()
        elif name == "rev":
            if client.speedwalks.has_key(erg[1]):
                path = client.speedwalks[erg[1]]
                speedwalk_reverse(client, path)
            else:
                client.output("No such path defined!\n")
                client.snl()
            
        else:
            if client.speedwalks.has_key(name):
                path = client.speedwalks[name]
                speedwalk(client, path)
            else:
                client.output("No such path defined!\n")
                client.snl()

def save_speedwalks(client, file):
    for k in client.speedwalks.keys():
        file.write("#sw add %s %s\n" % (k, re.sub(r";",r"\;",client.speedwalks[k])))

speedwalk_defined=1
save_functions.append(save_speedwalks)
addcommand(client, "#sw", sw)
addcommand(client, "#writesw",write_speedwalks)




